#!/bin/sh
set -x
set -e
i386-pc-mingw32-gcc -O2 -fomit-frame-pointer -S shared.c
../mingw-libtool --mode=compile i386-pc-mingw32-gcc -O2 -fomit-frame-pointer -c shared.c
i386-pc-mingw32-gcc -O2 -fomit-frame-pointer -S shared2.c
../mingw-libtool --mode=compile i386-pc-mingw32-gcc -O2 -fomit-frame-pointer -c shared2.c

# Resolve self-references.
objects="shared.lo shared2.lo"
lo_to_o='s,\.lo$,.o,'
(for o in $objects; do
   i386-pc-mingw32-nm .libs/`echo $o | sed -e "$lo_to_o"`
 done
) | sed -n -e 's,^.* U __imp__\(.*\),\1,p' | LC_ALL=C sort | LC_ALL=C uniq > needed-imps
(for o in $objects; do
   i386-pc-mingw32-nm .libs/`echo $o | sed -e "$lo_to_o"`
 done
) | sed -n -e 's,^.* T _\(.*\),\1,p' | LC_ALL=C sort | LC_ALL=C uniq > defined-text-syms
(for o in $objects; do
   i386-pc-mingw32-nm .libs/`echo $o | sed -e "$lo_to_o"`
 done
) | sed -n -e 's,^.* [DR] _\(.*\),\1,p' | LC_ALL=C sort | LC_ALL=C uniq > defined-data-syms
cat defined-text-syms defined-data-syms | LC_ALL=C sort > defined-syms
LC_ALL=C join needed-imps defined-syms | \
  sed -e 's/^\(.*\)$/extern int \1; void *_imp__\1 = \&\1;/' > exports.c
i386-pc-mingw32-gcc -O2 -fomit-frame-pointer -S exports.c
../mingw-libtool --mode=compile i386-pc-mingw32-gcc -O2 -fomit-frame-pointer -c exports.c

# But apparently, those symbols for which an _imp__ is already defined in the
# DLL are not put into the libshared.dll.a. To work around this, need to export
# these symbols explicitly. And then, of course, we need --export-all-symbols
# because it is no longer the default.
(
  LC_ALL=C join needed-imps defined-text-syms | \
    sed -e 's/^\(.*\)$/asm (".section .drectve\\n"); asm (".ascii \\" -export:\1\\"\\n"); extern int \1; void *_imp__\1 = \&\1;/'
  LC_ALL=C join needed-imps defined-data-syms | \
    sed -e 's/^\(.*\)$/asm (".section .drectve\\n"); asm (".ascii \\" -export:\1,data\\"\\n"); extern int \1; void *_imp__\1 = \&\1;/'
) > exports.c
i386-pc-mingw32-gcc -O2 -fomit-frame-pointer -S exports.c
../mingw-libtool --mode=compile i386-pc-mingw32-gcc -O2 -fomit-frame-pointer -c exports.c

# Now link the shared library.
../mingw-libtool --mode=link i386-pc-mingw32-gcc -O2 -fomit-frame-pointer -Wl,--disable-auto-import -Wl,--export-all-symbols -o libshared.la -rpath `pwd` -no-undefined $objects exports.lo

i386-pc-mingw32-gcc -O2 -fomit-frame-pointer -S main.c
i386-pc-mingw32-gcc -O2 -fomit-frame-pointer -c main.c
../mingw-libtool --mode=link i386-pc-mingw32-gcc -O2 -fomit-frame-pointer -Wl,--disable-auto-import -o main.exe main.o -L. -lshared
i386-pc-mingw32-objdump --disassemble -r .libs/main.exe > main.exe.disasm
